Description

When provisioning with puppet enabled, the 422 Unprocessable Entity error gets produced every time
with the first puppet run.

Also, this prevents other types of facts (such as subscription-manager ones) to be refused as well.

I'm not sure about the reasons why it's there but it would be nice if we could address this
in a bit better way than it is right now.

History

#1 - 06/29/2016 11:18 AM - Ivan Necas
- Subject changed from 422 Unprocessable Entity in production.log to Facts not being imported when in build mode

- Description updated

#2 - 06/30/2016 07:29 AM - Daniel Lobato Garcia

https://qgithub.com/theforeman/foreman/blob/develop/app/models/host/base.rb#L 144 is what's preventing them to be imported.

| suppose the reason is that when that line was written (2013, and it seems that the method was written well before then) there was no reason why a
host would get facts without being built.

If you're getting the 422 because of that line, try to remove it, write a small test & I'd be happy to review :)

#3 - 06/30/2016 07:35 AM - Dominic Cleal

Configuration management facts determined from the build environment may be significantly different to facts from the post-build/runtime
environment, so shouldn't be imported during build. The importers may change associations or attributes of the host, like OS or network interface
details.

#4 - 06/30/2016 07:35 AM - Dominic Cleal

- Category changed from Inventory to Importers

#5 - 07/12/2016 03:08 PM - Marek Hulan

So this behavior should be perhaps configurable per importer type?

#6 - 07/13/2016 03:08 AM - Ivan Necas

what about importing the facts but not transferring it to associations in built phase? Btw. the ultimate solution would be if

the facts didn't influence the provisioning part. I've seen many times the OS fact import preaking the re-build functionality.

#7 - 08/02/2017 02:59 PM - Marek Hulan

- Status changed from New to Rejected

I'm closing this since | think Dominic explained the reason. Separation of facts and influence on OS is | believed tracked elsewhere. Feel free to
reopen if | misunderstood.

05/18/2024 1/1



https://github.com/theforeman/foreman/blob/develop/app/models/host/base.rb#L144
http://www.tcpdf.org

